//
//  SSAudioControl.h
//  SSAudioControl
//
//  Created by Lion Mac OS on 11/15/13.
//  Copyright (c) 2013 Lion Mac OS. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreAudio/CoreAudio.h>

extern NSString * const kSSAudioDeviceID;  ///NSNumber short...
extern NSString * const kSSAudioDeviceName;  ////NSString....
extern NSString * const kSSAudioDeviceInputChannel; ////NSNumber Integer

@class SSAudioControl;
@protocol SSAudioControlDelegate <NSObject>
-(void)audioControlInputDeviceChanged:(SSAudioControl *)ac;
@end

@interface SSAudioControl : NSObject
{
    id<SSAudioControlDelegate> _delegate;
}
+(SSAudioControl *)sharedAudioControl;
//-(BOOL)hasProperty:(const AudioObjectPropertyAddress *)theAddress withDevice:(AudioObjectID)objID;


-(NSArray *)inputDevicesName;
-(NSString *)defaultDeviceName;
-(AudioObjectID)defaultDeviceID;
-(AudioObjectID)deviceIDFromName:(NSString *)name;
+(NSString *)deviceUIDFromID:(AudioObjectID)objID;
-(NSString *)deviceIDToName:(AudioObjectID)objID;
-(NSInteger)deviceInputChannelCountFromName:(NSString *)name;
-(NSArray *)deviceAvaliableNominalSampleRateRangesFromName:(NSString *)name;
-(CGFloat)defaultDeviceSampleRateFromName:(NSString *)name;
-(NSArray *)deviceAvaliableVirtualFormatFromName:(NSString *)name;
-(NSArray *)deviceAvaliablePhysicalFormatFromName:(NSString *)name;
-(AudioStreamBasicDescription)deviceCurrentVirtualFormatFromName:(NSString *)name;
-(AudioStreamBasicDescription)deviceCurrentPhysicalFormatFromName:(NSString *)name;

-(NSInteger)deviceInputChannelCountFromID:(AudioObjectID)objID;
-(NSArray *)deviceAvaliableNominalSampleRateRangesFromID:(AudioObjectID)objID;
-(CGFloat)defaultDeviceSampleRateFromID:(AudioObjectID)objID;
/////Object is NSData: AudioStreamRangeDescription;
-(NSArray *)deviceAvaliableVirtualFormatFromID:(AudioObjectID)objID;
-(NSArray *)deviceAvaliablePhysicalFormatFromID:(AudioObjectID)objID;
-(AudioStreamBasicDescription)deviceCurrentVirtualFormatFromID:(AudioObjectID)objID;
-(AudioStreamBasicDescription)deviceCurrentPhysicalFormatFromID:(AudioObjectID)objID;


-(AudioObjectID)defaultOutputDeviceID;


@property(readwrite, retain) id<SSAudioControlDelegate> delegate;
@end
