//
//  SSAudioPlayer.h
//  SSAudioControl
//
//  Created by Lion Mac OS on 12/6/13.
//  Copyright (c) 2013 Lion Mac OS. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreAudio/CoreAudio.h>
typedef enum
{
    SSAudioPlayerReady,
    SSAudioPlayerPause,
    SSAudioPlayerPlaying,
    SSAudioPlayerStop,
}SSAudioPlayerState;
extern const UInt32 SSUnknownTotalPacketToPlay;
@class SSAudioPlayer;
@protocol SSAudioPlayerDelegate <NSObject>
-(void)SSAudioPlayer:(SSAudioPlayer *)audioPlayer playPacketCount:(SInt64)playPkt totalPacketCount:(UInt32)totalPkt
          withFormat:(const AudioStreamBasicDescription *)asbd;
-(void)SSAudioPlayerStopPlay:(SSAudioPlayer *)audioPlayer;
@optional
/*Only support LPCM format*/
-(void)SSAudioPlayer:(SSAudioPlayer *)audioPlayer
          fillBuffer:(void *const)inBuffer  /*out Data*/
          currentPkt:(SInt64)currentPkt     /*current packet read position*/
        fillPktCount:(UInt32 *)fillPktcount /*read packet count */
      fillBytesCount:(UInt32 *)fillBtyes    /*out data size*/
          withFormat:(const AudioStreamBasicDescription *)asbd;
@end

@interface SSAudioPlayer : NSObject
{
@private
    SSAudioPlayerState _state;
    id<SSAudioPlayerDelegate> _delegate;
}

-(BOOL)playWithFile:(NSString *)audioFile;
-(BOOL)playWithDataFormat:(const AudioStreamBasicDescription *)dataFormat;

/*volume: 0-200*/
-(void)adjustVolume:(NSUInteger)volume;
-(void)pause;
-(void)resume;
-(void)stop;

@property(readonly) SSAudioPlayerState state;
@property(readonly) NSString *audioPathFile;
@property(readwrite, retain) id<SSAudioPlayerDelegate> delegate;
@end
