//
//  SSAudioRecorder.h
//  SSAudioControl
//
//  Created by Lion Mac OS on 11/15/13.
//  Copyright (c) 2013 Lion Mac OS. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <CoreAudio/CoreAudio.h>

typedef enum{
    SSAudioRecorderReady,
    SSAudioRecorderPause,
    SSAudioRecorderRunning,
}SSAudioRecorderState;

@interface SSAudioRecorderData : NSObject<NSCoding>
-(id)initWithData:(NSData *)data format:(const AudioStreamBasicDescription *)asbd;
-(NSData *)data;
-(const AudioStreamBasicDescription *)dataFormat;
@end

@class SSAudioRecorder;
@protocol SSAudioRecorderDelegate <NSObject>
-(void)SSAudioRecorder:(SSAudioRecorder *)ar dataRecord:(const void *)data
              withSize:(UInt32)dataSize dataFormat:(const AudioStreamBasicDescription*)asbd;
@end

@interface SSAudioRecorder : NSObject

-(id)initWithDeviceID:(AudioObjectID)objID;
-(void)setDeviceID:(AudioObjectID)objID;
-(BOOL)startRecordWithOutFile:(NSString *)outfilePath;
-(BOOL)startRecordWithFormat:(const AudioStreamBasicDescription *)asbd outFile:(NSString *)outfilePath;
-(BOOL)startRecordWithFormat:(const AudioStreamBasicDescription *)asbd;
-(BOOL)startRecord;

-(void)pauseRecord;
-(void)resumeRecord;
-(void)stopRecord;
-(const AudioStreamBasicDescription *)currentDataFormat;
@property(readonly)SSAudioRecorderState state;
@property(readwrite, retain) id<SSAudioRecorderDelegate> delegate;
@end
